package com.example.mynotepad.Dialogs.FoldersCustomDialog;

import android.app.Dialog;
import android.content.Context;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.widget.LinearLayout;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.mynotepad.MenuFeatures.AllNotes.DataBase.FoldersEntity;
import com.example.mynotepad.MenuFeatures.AllNotes.DataBase.NoteDataBase;
import com.example.mynotepad.R;

public class FoldersDialog extends Dialog{
    private RecyclerView recyclerView;
    private LinearLayout addNewFolder;
    private String selectedFolderName;
    private FolderRecyclerViewAdapter folderRecyclerViewAdapter;

    public FoldersDialog(@NonNull final Context context) {
        super(context);
        final Dialog dialog = new Dialog(context);
        dialog.getWindow().setBackgroundDrawable(new ColorDrawable(android.graphics.Color.TRANSPARENT));
        dialog.setCancelable(true);
        dialog.setContentView(R.layout.dialog_folders);
        addNewFolder = dialog.findViewById(R.id.addFolder);
        recyclerView = dialog.findViewById(R.id.recyclerView2);
        folderRecyclerViewAdapter = new FolderRecyclerViewAdapter(NoteDataBase.getInstance(context).foldersDAO().getAllFolders(), context);
        recyclerView.setAdapter(folderRecyclerViewAdapter);
        recyclerView.setLayoutManager(new LinearLayoutManager(context, LinearLayoutManager.VERTICAL, false));
        folderRecyclerViewAdapter.setOnFolderClickListener(new OnFolderClickListener() {
            @Override
            public void itemClicked(String folderName) {
                selectedFolderName = folderName;
                dialog.dismiss();
            }

            @Override
            public void itemLongClicked() {

            }
        });
        dialog.show();

        addNewFolder.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CreateNewFolderDialog createNewFolderDialog = new CreateNewFolderDialog(new CreateNewFolderDialog.OnFolderCreatedListener() {
                    @Override
                    public void onCreated(FoldersEntity folder) {
                        folderRecyclerViewAdapter.notifyDataSetChanged(); // call this method back when you create the directory
                    }
                });
                createNewFolderDialog.showDialog(context);
            }
        });
    }
}
